/***************************************************************************
                          kcanvasitems.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by Marco Krohn
    email                : marco.krohn@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qpainter.h>

#include "kcanvasitems.h"

#include "gamelogic/stobj.h"





//----------------------------------------  KCIStellarObject  ----------------------------------------

KCIStellarObject :: KCIStellarObject( KCanvas* canvas, TStellarObject* stobj )
  : KCanvasItem( canvas )
{
  fStObj = stobj;
}



TStellarObject* KCIStellarObject :: getStellarObject() const
{
  return fStObj;
}



void KCIStellarObject :: setStellarObject( TStellarObject* stobj )
{
  fStObj = stobj;
}





//----------------------------------------  KCISystem  ----------------------------------------

KCIFleet :: KCIFleet( KCanvas* canvas, TStellarObject* stobj )
  : KCIStellarObject( canvas, stobj )
{
  // this guarantees a minimum painting area of 11x11 (2*5+1=11)
  setMinSize( 3 );
}



// virtual method
TRectangle KCIFleet :: getBoundingBox() const
{
TRectangle rect;

  double size = 3;
  rect.setRect( fStObj->getPos().getX()-size, fStObj->getPos().getY()-size, 2*size, 2*size );

  return rect;
}



// virtual method
void KCIFleet :: paint( QPainter& painter, double zoom, const TRectangle& rect ) const
{
int x,y;

  int size = 3;
  painter.setPen( Qt::NoPen );
  painter.setBrush( QColor(Qt::blue) );
  x = Round( fStObj->getPos().getX() * zoom );
  y = Round( fStObj->getPos().getY() * zoom );

  painter.drawRect( x-size, y-size, 2*size, 2*size);
}





//----------------------------------------  KCISystem  ----------------------------------------

KCISystem :: KCISystem( KCanvas* canvas, TStellarObject* stobj )
  : KCIStellarObject( canvas, stobj )
{
  setMinSize( 5 );
}



// virtual method
TRectangle KCISystem :: getBoundingBox() const
{
double size;
TRectangle rect;

  size = 5;
  rect.setRect( fStObj->getPos().getX()-size, fStObj->getPos().getY()-size, 2*size, 2*size );

  return rect;
}



// virtual method
void KCISystem :: paint( QPainter& painter, double zoom, const TRectangle& rect ) const
{
int x,y;

  painter.setPen( Qt::NoPen );
  painter.setBrush( QColor(110,220,40) );  // Qt::green
  x = Round( fStObj->getPos().getX() * zoom );
  y = Round( fStObj->getPos().getY() * zoom );

  painter.drawEllipse( x, y, 5, 5);
}

