/***************************************************************************
                          kcanvasitems.h  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by Marco Krohn
    email                : marco.krohn@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __KCANVAS_ITEMS_INCLUDED
#define __KCANVAS_ITEMS_INCLUDED

#include "kcanvas.h"

class TStellarObject;





//----------------------------------------  KCIStellarObject  ----------------------------------------

class KCIStellarObject : public KCanvasItem
{
  public:
    KCIStellarObject( KCanvas* canvas, TStellarObject* stobj );

    TStellarObject* getStellarObject() const;
    void setStellarObject( TStellarObject* stobj );

  protected:
    TStellarObject* fStObj;
};







//----------------------------------------  KCIFleet  ----------------------------------------

/**
* The canvas item for fleets.
*/
class KCIFleet : public KCIStellarObject
{
  public:
    KCIFleet( KCanvas* canvas, TStellarObject* stobj );

    /**
    * @return Size of the bouding box (world coord.)
    */
    virtual TRectangle getBoundingBox() const;
    /**
    * Paints the fleet on a paint device using a painter.
    * @param painter The painter for painting on the paint device.
    * @param zoom The current used zoom for viewing the item.
    */
    virtual void paint( QPainter& painter, double zoom, const TRectangle& rect ) const;
};





//----------------------------------------  KCISystem  ----------------------------------------

/**
* The canvas item for systems.
*/
class KCISystem : public KCIStellarObject
{
  public:
    KCISystem( KCanvas* canvas, TStellarObject* stobj );

    /**
    * @return Size of the bouding box (world coord.)
    */
    virtual TRectangle getBoundingBox() const;
    /**
    * Paints a system on a paint device using a painter.
    * @param painter The painter for painting on the paint device.
    * @param zoom The current used zoom for viewing the item.
    */
    virtual void paint( QPainter& painter, double zoom, const TRectangle& rect ) const;
};





#endif        // __KCANVAS_ITEMS_INCLUDED
