/***************************************************************************
                          kgalaxydoc.cpp  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by Marco Krohn
    email                : marco.krohn@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "kgalaxydoc.h"
#include "kcanvasitems.h"

#include "gamelogic/galaxy.h"





//----------------------------------------  KGalaxyDoc  ----------------------------------------

KGalaxyDoc :: KGalaxyDoc( TGalaxy* galaxy )
  : KCanvas( (galaxy->getSize()).getX(), (galaxy->getSize()).getY() )
{
  fGalaxy = galaxy;
  setModified( false );

  TStellarObjectList SystemList;
  fGalaxy->getStellarObjectList().Filter(&SystemList, TSOLFilterType(TType::SYSTEM));

  TStellarObjectList::iterator it;
  for ( it=SystemList.begin(); it!=SystemList.end(); it++ )  {
    KCISystem* sys = new KCISystem( this, *it );
    addCanvasItem( sys );
  }

  TStellarObjectList FleetRouteList;
  fGalaxy->getStellarObjectList().Filter(&FleetRouteList, TSOLFilterType(TType::FLEET));

  for ( it=FleetRouteList.begin(); it!=FleetRouteList.end(); it++ )  {
    KCIFleet* flt = new KCIFleet( this, *it );
    addCanvasItem( flt );
  }
}



// virtual method
KGalaxyDoc :: ~KGalaxyDoc()
{
}



TGalaxy* KGalaxyDoc :: getGalaxy() const
{
  return fGalaxy;
}



bool KGalaxyDoc :: isModified()
{
  return fModified;
}



// modified=true
void KGalaxyDoc :: setModified( bool modified )
{
  fModified = modified;
}





/**
* $Log: kgalaxydoc.cpp,v $
* Revision 1.2  2002/07/15 08:08:57  mkrohn5
* various changes
*
* Revision 1.1  2002/07/12 09:53:25  mkrohn5
* initial import
*
*/
