/***************************************************************************
                          kgalaxydoc.h  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by Marco Krohn
    email                : marco.krohn@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __KGALAXY_DOC_INCLUDED
#define __KGALAXY_DOC_INCLUDED

#include "kcanvas.h"

class TGalaxy;





//----------------------------------------  KGalaxyDoc  ----------------------------------------

/**
*
*/
class KGalaxyDoc : public KCanvas
{
  public:
    KGalaxyDoc( TGalaxy* galaxy );
    virtual ~KGalaxyDoc();

    /**
    * @return The galaxy this document refers to.
    */
    TGalaxy* getGalaxy() const;
    /**
    * @return @c true if the document was modified, otherwise @c false.
    */
    bool isModified();
    /**
    * Changes the status of the document.
    * @param modified New setting for @a fModified.
    */
    void setModified( bool modified=true );

  private:
    /**
    * The galaxy object which is visually represented by the views
    * (see KGalaxyView).
    */
    TGalaxy* fGalaxy;
    /**
    * Stores if the document has been modified or not.
    */
    bool fModified;
};





#endif        // __KGALAXY_DOC_INCLUDED
