/***************************************************************************
                          kgalaxyview.h  -  description
                             -------------------
    begin                : Wed Jul 10 2002
    copyright            : (C) 2002 by Marco Krohn
    email                : marco.krohn@gmx.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef __KGALAXYVIEW_INCLUDED
#define __KGALAXYVIEW_INCLUDED

#include <list>

#include "kcanvas.h"

class KGalaxyDoc;





//----------------------------------------  KGalaxyView  ----------------------------------------

class KGalaxyView : public KCanvasView
{
  Q_OBJECT

  public:
    KGalaxyView( KGalaxyDoc* doc, QWidget* parent, const char* name, int wflags );
    virtual ~KGalaxyView();

  protected:
    /**
    * fixme
    */
    virtual void keyPressEvent( QKeyEvent* e );
    /**
    * fixme
    */
    virtual void wheelEvent( QWheelEvent* e );

  protected slots:
    /**
    * Receives the current pos of the mouse, restrict the pos values such that
    * they are within the galaxy and finally informs asks the main window
    * to show the current position.
    */
    void showPos( TPoint pos );

  private:
    /**
    * The document this view refers to.
    */
    KGalaxyDoc* fDoc;
};





#endif        // __KGALAXYVIEW_INCLUDED
