// $Id: ra_fleet_movement.h,v 1.8 2002/06/22 18:23:36 mkrohn5 Exp $

// "Rule Atom Fleet Movement" Header File
// Written by: Marco Krohn, <marco.krohn@gmx.de>

// Copyright (C) 2001 - , Marco Krohn <marco.krohn@gmx.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

#ifndef __RA_FLEET_MOVEMENT_INCLUDED
#define __RA_FLEET_MOVEMENT_INCLUDED

#include "gamelogic/ruleatom.h"





//----------------------------------------  class TRuleAtomFleetMovement  ----------------------------------------

/**
* @class TRuleAtomFleetMovement
* @brief The base class for fleet movement.
* @author Marco Krohn <marco.krohn@gmx.de>
* @version $Id: ra_fleet_movement.h,v 1.8 2002/06/22 18:23:36 mkrohn5 Exp $
* @see TRuleAtom
*
* Defines and checks the parameters and the return values.
*
* <dl compact><dt><strong>Needed Information:</strong><dd>
* "fleet" (TLinkable*) = the fleet that wants to move.<br>
* "time" (@c double) = the time the fleet has to move (1.0 means one turn)</dl>
* <dl compact><dt><strong>Returns:</strong><dd>
* nothing</dl>
*
*/
DeclareRuleAtomBase(FleetMovement)
  CHECK("fleet");
  CHECK("time");
EndDeclareRuleAtomBase;





//----------------------------------------  class TRuleAtomFleetMovementBasic  ----------------------------------------

/**
* @class TRuleAtomFleetMovementBasic
* @brief The basic rules for fleet movement.
* @author Marco Krohn <marco.krohn@gmx.de>
* @version $Id: ra_fleet_movement.h,v 1.8 2002/06/22 18:23:36 mkrohn5 Exp $
* @see TRuleAtomFleetMovement
*
* This rule atom provides the basic rules for fleet movement.
*
* <br><br><br>
* <dl compact><dt><strong>Name:</strong><dd>
* Fleet Engine Failure</dl>
* <dl compact><dt><strong>Ruleset:</strong><dd>
* Basic</dl>
* <dl compact><dt><strong>Description:</strong><dd>
* FIXME.</dl>
* <dl compact><dt><strong>Needed modules:</strong><dd>
* none</dl>
*/
DeclareRuleAtom(FleetMovement,Basic)
EndDeclareRuleAtom;





#endif        // __RA_FLEET_MOVEMENT_INCLUDED
