// $Id: ra_item_access.cpp,v 1.3 2002/07/12 10:06:14 mkrohn5 Exp $

// Rule Atom ItemAccess Code File
// Written by: Marco Krohn, <marco.krohn@gmx.de>

// Copyright (C) 2001 - , Marco Krohn, <marco.krohn@gmx.de>
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

#include "gamelogic/ruleatoms/ra_item_access.h"
#include "gamelogic/rulesystem.h"





//----------------------------------------  class TRAItemAccess  ----------------------------------------

TRAItemAccess :: TRAItemAccess() : TRuleAtom()
{
}



// virtual method
bool TRAItemAccess :: provideMissingInfo()
{
  if ( getInfo("item") == 0 )  return false;
  return true;
}





//----------------------------------------  class TRAItemAccessBasic  ----------------------------------------

TRAItemAccessBasic :: TRAItemAccessBasic() : TRAItemAccess()
{
}



// virtual method
bool TRAItemAccessBasic :: checkDependencies( const TRuleSystem* rules,
                                       list<TRuleSystem::tError>* errors ) const
{
  return true;
}



// virtual method
bool TRAItemAccessBasic :: execute()
{
  if ( TRAItemAccess::provideMissingInfo() == false )  return false;
  // FIXME: insert your basic rule atom code here
  return true;
}





//----------------------------------------  class TRAItemAccessStars  ----------------------------------------

TRAItemAccessStars :: TRAItemAccessStars() : TRAItemAccess()
{
}



// virtual method
bool TRAItemAccessStars :: checkDependencies( const TRuleSystem* rules,
                                       list<TRuleSystem::tError>* errors ) const
{
  return true;
}



// virtual method
bool TRAItemAccessStars :: execute()
{
  if ( TRAItemAccess::provideMissingInfo() == false )  return false;
  // FIXME: insert your stars! rule atom code here
  return true;
}





//----------------------------------------  class TRAItemAccessSL  ----------------------------------------

TRAItemAccessSL :: TRAItemAccessSL() : TRAItemAccess()
{
}



// virtual method
bool TRAItemAccessSL :: checkDependencies( const TRuleSystem* rules,
                                       list<TRuleSystem::tError>* errors ) const
{
  return true;
}



// virtual method
bool TRAItemAccessSL :: execute()
{
  if ( TRAItemAccess::provideMissingInfo() == false )  return false;
  // FIXME: insert your Stellar Legacy rule atom code here
  return true;
}





/*
* $Log: ra_item_access.cpp,v $
* Revision 1.3  2002/07/12 10:06:14  mkrohn5
* include path fix
*
* Revision 1.2  2001/12/04 00:32:03  mkrohn5
* a few corrections
*
* Revision 1.1  2001/12/03 01:37:48  mkrohn5
* - various updates and extensions
* - also two new rule atoms: item_access, fleet_engine_failure
*
*
*/
