// ----------------------------------------------------------------------------
//
// Simple string class
//
// Copyright (C) 1999, Pier Donini, Pier.Donini@epfl.ch
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 1, or (at your option)
// any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details. 
//
// ----------------------------------------------------------------------------

#include <string.h>
#include <strings.h>
#include <assert.h>
#include "cstring.h"


void string::Allocate(const char *Chars)
{
  fBuffer = new char[strlen(Chars) + 1];
  strcpy(fBuffer, Chars);
}


string::string()
{
  fBuffer = new char[1];
  fBuffer[0] = '\0';
}


string::~string()
{
  delete[] fBuffer;
}


string& string::Append(const char *Chars)
{
  int length = strlen(fBuffer) + strlen(Chars);
  char *res = new char[length + 1];

  strcpy(res, fBuffer);
  delete[] fBuffer;
  strcat(res, Chars);
  res[length] = '\0';
  fBuffer = res;

  return *this;
}


string Concat(const char *One, const char *Two)
{
  string tmp(One);
  tmp.Append(Two);
  return tmp;
}


string& string::Set(const char *Chars)
{
  delete[] fBuffer;
  int length = strlen(Chars);
  fBuffer = new char[length + 1];
  strcpy(fBuffer, Chars);
  fBuffer[length] = '\0';

  return *this;
}


char& string::operator[](unsigned int Index)
{
  assert(Index <= strlen(fBuffer));
  return fBuffer[Index];
}
