/***************************************************************************
                          stringtools.h  -  description
                             -------------------
    begin                : Sat Apr 8 2000
    copyright            : (C) 2000 by Marco Krohn
    email                : mkrohn@stud.uni-hannover.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef STRING_TOOLS_INCLUDED
#define STRING_TOOLS_INCLUDED

#include <string>

using namespace std;





class TStringTools
{
  public:
    TStringTools();

    static int ConvertToInteger(const string& str);
    static double ConvertToFloat(const string& str);
    static int CountNumberOfChars(const string& str, char c);
    static void DeleteLastChar(string& str);
    bool ReadEquation(string& str, string& lhs, string& rhs, bool bRemove=false);
    string ReadNextBlock(string& str, const string& sElements, bool bRemove=false) const;
    string ReadNextString(string& str, bool bRemove=false) const;
    string ReadNextToken(string& str, bool bRemove=false) const;
    string ReadNextWord(string& str, bool bRemove=false) const;
    static void RemoveCharsFromStringBegin(string& str, const string sRemove=" \t\n\r");
    static void RemoveCharsFromStringEnd(string& str, const string sRemove=" \t\n\r");
    static void Replace(string& str, const string& search, const string replace);
    // don't use \0 as a seperator element (this is already hardwired seperator element;
    // otherwise this will probably cause problems)
    void SetSeperatorElements(const string& str) { sSepElements=str; }
    void SetWordElements(const string& str) { sWordElements=str; }

  private:
    string sWordElements;
    string sSepElements;
    string sStringStartSeq, sStringStopSeq, sStringStopIgnore;
};



#endif        // STRING_TOOLS_INCLUDED